Index: branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 11576)
+++ branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 11577)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Operators.Views</RootNamespace>
     <AssemblyName>HeuristicLab.Operators.Views-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <TargetFrameworkProfile>
     </TargetFrameworkProfile>
@@ -46,4 +46,5 @@
     <WarningLevel>4</WarningLevel>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -57,4 +58,5 @@
     </DocumentationFile>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
@@ -66,4 +68,5 @@
     <ErrorReport>prompt</ErrorReport>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
@@ -77,4 +80,5 @@
     <ErrorReport>prompt</ErrorReport>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
@@ -86,4 +90,5 @@
     <ErrorReport>prompt</ErrorReport>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
@@ -97,4 +102,5 @@
     <ErrorReport>prompt</ErrorReport>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <Prefer32Bit>false</Prefer32Bit>
   </PropertyGroup>
   <ItemGroup>
@@ -129,4 +135,10 @@
       <DependentUpon>CheckedMultiOperatorView.cs</DependentUpon>
     </Compile>
+    <Compile Include="HookOperatorView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HookOperatorView.Designer.cs">
+      <DependentUpon>HookOperatorView.cs</DependentUpon>
+    </Compile>
     <Compile Include="MultiOperatorView.cs">
       <SubType>UserControl</SubType>
@@ -253,5 +265,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -260,5 +272,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.Designer.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.Designer.cs	(revision 11577)
+++ branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.Designer.cs	(revision 11577)
@@ -0,0 +1,138 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Operators.Views {
+  partial class HookOperatorView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.portGroupBox = new System.Windows.Forms.GroupBox();
+      this.clearPortButton = new System.Windows.Forms.Button();
+      this.portView = new HeuristicLab.Core.Networks.Views.PortView();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.portGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // breakpointCheckBox
+      // 
+      this.toolTip.SetToolTip(this.breakpointCheckBox, "Check if an engine should stop execution each time after this operator has been p" +
+        "rocessed.");
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Location = new System.Drawing.Point(0, 101);
+      this.parameterCollectionView.Size = new System.Drawing.Size(490, 252);
+      this.parameterCollectionView.TabIndex = 6;
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      // 
+      // portGroupBox
+      // 
+      this.portGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.portGroupBox.Controls.Add(this.clearPortButton);
+      this.portGroupBox.Controls.Add(this.portView);
+      this.portGroupBox.Location = new System.Drawing.Point(0, 46);
+      this.portGroupBox.Name = "portGroupBox";
+      this.portGroupBox.Size = new System.Drawing.Size(490, 49);
+      this.portGroupBox.TabIndex = 5;
+      this.portGroupBox.TabStop = false;
+      this.portGroupBox.Text = "Port:";
+      // 
+      // clearPortButton
+      // 
+      this.clearPortButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Remove;
+      this.clearPortButton.Location = new System.Drawing.Point(6, 19);
+      this.clearPortButton.Name = "clearPortButton";
+      this.clearPortButton.Size = new System.Drawing.Size(24, 24);
+      this.clearPortButton.TabIndex = 0;
+      this.clearPortButton.UseVisualStyleBackColor = true;
+      this.clearPortButton.Click += new System.EventHandler(this.clearPortButton_Click);
+      // 
+      // portView
+      // 
+      this.portView.AllowDrop = true;
+      this.portView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.portView.Caption = "Port View";
+      this.portView.Content = null;
+      this.portView.Location = new System.Drawing.Point(36, 21);
+      this.portView.Name = "portView";
+      this.portView.ReadOnly = true;
+      this.portView.Size = new System.Drawing.Size(429, 24);
+      this.portView.TabIndex = 1;
+      this.portView.DragDrop += new System.Windows.Forms.DragEventHandler(this.portView_DragDrop);
+      this.portView.DragEnter += new System.Windows.Forms.DragEventHandler(this.portView_DragEnterOver);
+      this.portView.DragOver += new System.Windows.Forms.DragEventHandler(this.portView_DragEnterOver);
+      // 
+      // HookOperatorView
+      // 
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.portGroupBox);
+      this.Name = "HookOperatorView";
+      this.Controls.SetChildIndex(this.breakpointCheckBox, 0);
+      this.Controls.SetChildIndex(this.breakpointLabel, 0);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
+      this.Controls.SetChildIndex(this.portGroupBox, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.portGroupBox.ResumeLayout(false);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.GroupBox portGroupBox;
+    protected HeuristicLab.Core.Networks.Views.PortView portView;
+    protected System.Windows.Forms.Button clearPortButton;
+
+
+
+  }
+}
Index: branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.cs	(revision 11577)
+++ branches/OptimizationNetworks/HeuristicLab.Operators.Views/3.3/HookOperatorView.cs	(revision 11577)
@@ -0,0 +1,91 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core.Networks;
+using HeuristicLab.MainForm;
+using System;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Operators.Views {
+  [View("HookOperator View")]
+  [Content(typeof(HookOperator), true)]
+  [Content(typeof(IHookOperator), false)]
+  public partial class HookOperatorView : OperatorView {
+    public new IHookOperator Content {
+      get { return (IHookOperator)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public HookOperatorView() {
+      InitializeComponent();
+      errorProvider.SetIconAlignment(portView, ErrorIconAlignment.MiddleRight);
+      errorProvider.SetIconPadding(portView, 2);
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.PortChanged -= Content_PortChanged;
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.PortChanged += Content_PortChanged;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      portView.Content = Content == null ? null : Content.Port;
+      parameterCollectionView.Content = Content == null ? null : Content.Parameters;
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      portGroupBox.Enabled = Content != null && !ReadOnly && !Locked;
+      clearPortButton.Enabled = Content != null && Content.Port != null && !ReadOnly && !Locked;
+    }
+
+    protected virtual void Content_PortChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_PortChanged), sender, e);
+      else {
+        clearPortButton.Enabled = Content.Port != null && !ReadOnly && !Locked;
+        portView.Content = Content.Port;
+      }
+    }
+
+    protected virtual void clearPortButton_Click(object sender, EventArgs e) {
+      Content.Port = null;
+    }
+    protected virtual void portView_DragEnterOver(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      var data = e.Data.GetData(HeuristicLab.Common.Constants.DragDropDataFormat) as IMessagePort;
+
+      if (!ReadOnly && (data != null)) {
+        e.Effect = DragDropEffects.Link;
+      }
+    }
+    protected virtual void portView_DragDrop(object sender, DragEventArgs e) {
+      if (e.Effect != DragDropEffects.None) {
+        var port = e.Data.GetData(HeuristicLab.Common.Constants.DragDropDataFormat) as IMessagePort;
+        Content.Port = port;
+      }
+    }
+  }
+}
